/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.PBattleEnd
 *  fire.pb.clan.ClanUtils
 *  fire.pb.instancezone.timer.InstDestroyTimer
 *  fire.pb.map.DuplicateHelper
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  mkdb.Executor
 *  mkdb.Procedure
 *  xtable.Properties
 *  xtable.Roleid2battleid
 */
package fire.pb.instancezone;

import fire.pb.battle.PBattleEnd;
import fire.pb.clan.ClanUtils;
import fire.pb.instancezone.InstanceZone;
import fire.pb.instancezone.InstanceZoneFactory;
import fire.pb.instancezone.PDeleteRole2Inst;
import fire.pb.instancezone.timer.InstDestroyTimer;
import fire.pb.map.DuplicateHelper;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.concurrent.TimeUnit;
import mkdb.Executor;
import mkdb.Procedure;
import xtable.Properties;
import xtable.Roleid2battleid;

public class PTransOutRole
extends Procedure {
    private final long landkey;
    private final int posx;
    private final int posy;

    public PTransOutRole(long landkey, int posx, int posy) {
        this.landkey = landkey;
        this.posx = posx;
        this.posy = posy;
    }

    protected boolean process() throws Exception {
        InstanceZone instzone = InstanceZoneFactory.getInstanceZone(this.landkey, true);
        if (instzone == null) {
            return false;
        }
        HashSet<Long> inbattleid = new HashSet<Long>();
        HashSet<Long> transOuts = new HashSet<Long>();
        for (Long roleid : instzone.getRoleIds()) {
            Long battleId = Roleid2battleid.select((Long)roleid);
            if (battleId == null) {
                transOuts.add(roleid);
                this.transferRoleOutZone(roleid);
                continue;
            }
            inbattleid.add(battleId);
        }
        for (Long battleId : inbattleid) {
            Procedure.pexecuteWhileCommit((Procedure)new PBattleEnd(battleId.longValue(), 0));
        }
        if (transOuts.size() != 0) {
            ArrayList<Long> transrole = new ArrayList<Long>(transOuts.size());
            transrole.addAll(transOuts);
            Procedure.pexecuteWhileCommit((Procedure)new PDeleteRole2Inst(transrole));
        }
        Executor.getInstance().schedule((Runnable)new InstDestroyTimer(this.landkey), 60L, TimeUnit.SECONDS);
        return true;
    }

    public void transferRoleOutZone(long roleId) {
        Long clankey = Properties.selectClankey((Long)roleId);
        if (clankey == null || clankey <= 0L) {
            MessageMgr.sendMsgNotify((long)roleId, (int)145077, null);
            return;
        }
        Team team = TeamManager.selectTeamByRoleId((long)roleId);
        if (team != null) {
            if (team.isTeamLeader(roleId)) {
                DuplicateHelper.enterDynamicSceneWhileCommit((long)roleId, (int)ClanUtils.MAPID, (int)this.posx, (int)this.posy, (long)clankey, (String)"", (int)-1, (int)0, (int)516030, null);
            } else if (team.isAbsentMember(roleId)) {
                DuplicateHelper.enterDynamicSceneWhileCommit((long)roleId, (int)ClanUtils.MAPID, (int)this.posx, (int)this.posy, (long)clankey, (String)"", (int)-1, (int)0, (int)516030, null);
            }
        } else {
            DuplicateHelper.enterDynamicSceneWhileCommit((long)roleId, (int)ClanUtils.MAPID, (int)this.posx, (int)this.posy, (long)clankey, (String)"", (int)-1, (int)0, (int)516030, null);
        }
    }
}

